import sqlite3
import sqlite3 as sql
import os
import sys
import uuid
from flask import Flask, request, jsonify, make_response
import json

app = Flask(__name__)

checkFile = "/db/commFile"
database = "webhooks.db"
db_credentials = {
    "username": "admin",
    "password": "password"
}


def reset_table(connection):
    connection.cursor().execute("DROP TABLE webhooks")
    connection.cursor().execute("CREATE TABLE webhooks (uuid TEXT PRIMARY KEY, reciever TEXT, recieverSettings JSON, provider TEXT, providerSettings JSON, user TEXT, action TEXT)")


def add_data(connection, rec, recSet, prov, provSet, user, action):
    uid = str(uuid.uuid4())
    connection.cursor().execute("INSERT INTO webhooks VALUES (?, ?, ?, ?, ?, ?, ?)", (uid, rec, json.dumps(recSet), prov, json.dumps(provSet), user, action))
    connection.commit()
    for i in connection.cursor().execute("SELECT * FROM webhooks WHERE uuid = ?", (uid,)):
        return json.dumps(i)
    data = connection.cursor().execute("SELECT * FROM webhooks WHERE uuid = ?", (uid,))
    return data


def get_data(connection):
    data = connection.cursor().execute("SELECT * FROM webhooks")
    connection.commit()
    return data


def get_data_by_uuid(connection, uid):
    data = connection.cursor().execute("SELECT * FROM webhooks WHERE uuid = ?", (uid,))
    connection.commit()
    return data


def get_data_by_user(connection, user):
    data = connection.cursor().execute("SELECT * FROM webhooks WHERE user = ?", (user,))
    connection.commit()
    return data


def remove_connection(connection, uid):
    data = connection.cursor().execute("DELETE FROM webhooks WHERE uuid = ?", (uid,))
    connection.commit()
    return data


def update_data(connection, better_jason, uid):
    if "rec" in better_jason:
        print("in rec")
        connection.cursor().execute("UPDATE webhooks SET reciever = ? WHERE uuid = ?", (better_jason["rec"], str(uid)))
        connection.commit()
    if "recSet" in better_jason:
        connection.cursor().execute("UPDATE webhooks SET recieverSettings = ? WHERE uuid = ?", (str(better_jason["recSet"]), str(uid)))
        connection.commit()
    if "prov" in better_jason:
        connection.cursor().execute("UPDATE webhooks SET provider = ? WHERE uuid = ?", (str(better_jason["prov"]), str(uid)))
        connection.commit()
    if "provSet" in better_jason:
        connection.cursor().execute("UPDATE webhooks SET providerSettings = ? WHERE uuid = ?", (better_jason["provSet"], str(uid)))
        connection.commit()
    if "usr" in better_jason:
        connection.cursor().execute("UPDATE webhooks SET user = ? WHERE uuid = ?", (str(better_jason["usr"]), str(uid)))
        connection.commit()
    if "action" in better_jason:
        connection.cursor().execute("UPDATE webhooks SET action = ? WHERE uuid = ?", (str(better_jason["action"]), str(uid)))
        connection.commit()
    data = connection.cursor().execute("SELECT * FROM webhooks WHERE uuid = ?", (uid,))
    return data


@app.route('/', methods=['GET', 'POST'])
def form_example():
    print("Recieved Request")
    if request.method == 'POST':
        connection = sqlite3.connect("webhooks.db")
        better_jason = request.json
        command = better_jason["command"]
        if command.casefold() == "reset".casefold():
            reset_table(connection)
            return ''' <h1>Table Reset</h1>'''
        if command.casefold() == "add".casefold():
            data = add_data(connection, better_jason["rec"], better_jason["recSet"], better_jason["prov"],
                            better_jason["provSet"], better_jason["usr"], better_jason["action"])
            t = json.dumps({"test":"testsdfgfghdszggfds"})
            print(t)
            response = make_response({"test":"testsdfgfghdszggfds"}, 200,)
            response.headers["Content-Type"] = "application/json"
            response.headers["Content-Length"] = len({"test":"testsdfgfghdszggfds"})
            return 'POST'
        if command.casefold() == "get_all":
            data = get_data(connection)
            return json.dumps(data.fetchall())
        if command.casefold() == "get_uuid":
            data = get_data_by_uuid(connection, better_jason["uuid"])
            return json.dumps(data.fetchall())
        if command.casefold() == "get_user":
            data = get_data_by_user(connection, better_jason["user"])
            return json.dumps(data.fetchall())
        if command.casefold() == "remove":
            data = remove_connection(connection, better_jason["uuid"])
            return json.dumps(data.fetchall())
        if command.casefold() == "update":
            data = update_data(connection, better_jason, better_jason["uuid"])
            return json.dumps(data.fetchall())
        return ''' <h1>{} is an invalid command</h1>'''.format(command)
#     return json.dumps("test:test")

if __name__ == "__main__":
    Flask.debug = True
    app.run(host="0.0.0.0", port=8000, debug=True)

